#ifndef _CAPP_H_
    #define _CAPP_H_
 
#include <SDL.h>
#include <SDL_ttf.h>
#include "CEvent.h"
#include "CSurface.h"
#include "CPlayer.h"
#include <iostream>
#include <string>
 
class CApp  : public CEvent {
    private:

        bool            Running;

		TTF_Font* fontBig;
		TTF_Font* fontSmall;

        SDL_Surface*    Surf_Display;
		SDL_Surface*    Surf_MenuBG;
		SDL_Surface*    Surf_Play;
		SDL_Surface*    Surf_Quit;
		SDL_Surface*    Surf_ResetButton;
		SDL_Surface*    Surf_dialogueBG;
		SDL_Surface*    Surf_factionimpactBG;
		SDL_Surface*    Surf_globalimpactBG;
		SDL_Surface*    Surf_loseBG;
		SDL_Surface*    Surf_winBG;
		SDL_Surface*    Surf_worldviewBG;
		SDL_Surface*    Surf_left;
		SDL_Surface*    Surf_right;
		SDL_Surface*    Surf_Text;
		SDL_Surface*    Surf_Black;
		SDL_Surface*    Surf_White;
		SDL_Surface*    Surf_confirm;
		SDL_Surface*    Surf_choiceA;
		SDL_Surface*    Surf_choiceB;
		SDL_Surface*    Surf_cursor;
		SDL_Surface*    Surf_nextDay;
		SDL_Surface*    Surf_Esc;
		SDL_Surface*    Surf_Win0;
		SDL_Surface*    Surf_Win1;
		SDL_Surface*    Surf_Win2;
		SDL_Surface*    Surf_Win3;
		SDL_Surface*    Surf_Win4;
   

		enum gameState { menu, dialogue, globalimpact, win };
		int currentState;

		bool mouseDownOnPlay;
		bool mouseDownOnQuit;
		bool mouseOverPlay;
		bool mouseOverQuit;
		bool mouseOverChoiceA;
		bool mouseDownOnChoiceA;
		bool mouseOverChoiceB;
		bool mouseDownOnChoiceB;
		bool ChoiceA;
		bool ChoiceB;
		bool mouseOverConfirm;
		bool mouseDownOnConfirm;
		bool mouseOverNextDay;
		bool mouseOverEsc;

		CPlayer* player;

		std::string text[1000][20];

		const char* charString;
		SDL_Color textColour;

		int OldTime;


 
    public:
        CApp();
 
        int OnExecute();
 
    public:
        bool OnInit();

			SDL_Color CApp::make_color(Uint8 r, Uint8 g, Uint8 b); 
 
        void OnEvent(SDL_Event* Event);

			void CApp::changeState(gameState state);

			void CApp::OnExit();

			void CApp::OnMouseMove(int mX, int mY, int relX, int relY, bool Left, bool Right, bool Middle);

			void CApp::OnLButtonDown(int mX, int mY); 

			void CApp::OnLButtonUp(int mX, int mY);
 
        void OnLoop();
 
        void OnRender();
			
        void OnCleanup();
};
 
#endif