#include "CApp.h"
#include "tinyxml.h"

bool CApp::OnInit() {
	//initialize SDL
    if(SDL_Init(SDL_INIT_EVERYTHING) < 0) {
        return false;
    }

 	 //initialize SDL_ttf
    if( TTF_Init() == -1 )
    {
        return false;    
    }
    if((Surf_Display = SDL_SetVideoMode(1280, 720, 32, SDL_HWSURFACE | SDL_DOUBLEBUF )) == NULL) {
        return false;
    }

	//Open the font
    fontBig = TTF_OpenFont( "./assets/fonts/MYRIADAM.ttf", 28 );
	fontSmall = TTF_OpenFont( "./assets/fonts/MYRIADAM.ttf", 16 );

	// set window title
	SDL_WM_SetCaption("PseudoStates", NULL);

	// loading images
	Surf_Play = CSurface::OnLoad("./assets/menu/play.png", 0);
	Surf_Quit = CSurface::OnLoad("./assets/menu/quit.png", 0);
	Surf_ResetButton = CSurface::OnLoad("./assets/menu/resetbutton.bmp", 1);
	Surf_dialogueBG = CSurface::OnLoad("./assets/dialogueBG.png", 0);
	Surf_factionimpactBG = CSurface::OnLoad("./assets/factionimpactBG.png", 0);
	Surf_loseBG = CSurface::OnLoad("./assets/loseBG.png", 0);
	Surf_winBG = CSurface::OnLoad("./assets/winBG.png", 0);
	Surf_globalimpactBG = CSurface::OnLoad("./assets/globalimpactBG.png", 0);
	Surf_left = CSurface::OnLoad("./assets/left.png", 0);
	Surf_right = CSurface::OnLoad("./assets/right.png", 0);
	Surf_MenuBG = CSurface::OnLoad("./assets/menuBG.png", 0);
	Surf_Black = CSurface::OnLoad("./assets/black.png", 0);
	Surf_choiceA = CSurface::OnLoad("./assets/choiceA.png", 0);
	Surf_choiceB = CSurface::OnLoad("./assets/choiceB.png", 0);
	Surf_White = CSurface::OnLoad("./assets/white.png", 0); 
	Surf_confirm = CSurface::OnLoad("./assets/confirm.png", 0); 
	Surf_cursor = CSurface::OnLoad("./assets/cursor.png", 0); 
	Surf_nextDay = CSurface::OnLoad("./assets/nextDay.png", 0);
	Surf_Esc = CSurface::OnLoad("./assets/esc.png", 0);
	Surf_Win0 = CSurface::OnLoad("./assets/win0.png", 0);
	Surf_Win1 = CSurface::OnLoad("./assets/win1.png", 0);
	Surf_Win2 = CSurface::OnLoad("./assets/win2.png", 0);
	Surf_Win3= CSurface::OnLoad("./assets/win3.png", 0);
	Surf_Win4 = CSurface::OnLoad("./assets/win4.png", 0);

	// initialise state to menu
	currentState = menu;
	mouseDownOnPlay = false;
	mouseDownOnQuit = false;
	mouseOverPlay = false;
	mouseOverQuit = false;
    mouseOverChoiceA = false;
	mouseDownOnChoiceA = false;
	ChoiceA = false;
	ChoiceB = false;
	mouseOverConfirm = false;
	mouseDownOnConfirm = false;
	mouseOverNextDay = false;
	mouseOverEsc = false;

	// initiate frame regulator
	OldTime = SDL_GetTicks();
	
	// initialise text
	SDL_Color textColour = { 0, 0, 0 };

	TiXmlDocument doc;
	if (!doc.LoadFile("./assets/text.xml"))
	{
		std::cout << "file load failed";
		return false;
	}


	TiXmlElement* root = doc.FirstChildElement();
	if (root == NULL)
	{
		doc.Clear();
		std::cout << "root is null";
	}

	// std::cout << "Root name: " << root->Value() << std::endl;
	int x = 0;
	int y = 0;

	for (TiXmlElement* elem = root->FirstChildElement(); elem != NULL; elem = elem->NextSiblingElement())
	{
		for (TiXmlElement* line = elem->FirstChildElement(); line != NULL; line = line->NextSiblingElement())
		{				
		// Place text element into array
		text[x][y] = line->Attribute("text");
		// printf("X:%d Y:%d %s\n", x, y, line->Attribute("text"));
		y++;
		
		}
		y=0;
		x++;

	}

	// create player
	player = new CPlayer();

    return true;
}

SDL_Color CApp::make_color(Uint8 r, Uint8 g, Uint8 b) 
{ 
SDL_Color c= { r, g, b }; 
return c; 
} 